# Git Command

#### create file .gitignore
```
touch .gitignore
```
#### initial git
```
git init
```

#### link git server
```
git remote add origin http://10.1.1.60/Support/3K.git
```

#### pull data from git server
```
git pull origin master
```

#### add to index stages All
```
git add -A
```

#### add to index stages new and modified, without deleted
```
git add .
```

#### add to index stages modified and deleted, without new
```
git add -u
```

#### set default user
```
git config --global user.email "support_myhr@csc.co.th"
git config --global user.name "support_myhr"
```

#### commit with message
```
git commit -m initial
```

#### commit with user
```
git -c user.name='Paul Draper' -c user.email='my@email.org' commit -m '...'
```

#### other
````
git config --global credential.helper 'cache --timeout=3600'
```




# Git patch and apply

#### create patch from tag to current 

format : git format-patch {{from_tag}} --stdout > {{path_to_patch_file}}
```
git format-patch v1 --stdout > ../v2.patch
```

#### apply patch to project

format : git apply {{path_to_patch_file}}
```
git apply my.patch
```



# Checkout and revert

#### git checkout to commit

ย้าย source code ไปยังจุดที่ commit ไว้ 

format : git checkout {commit id}
```
git checkout 8ec6
```

#### git checkout to master

ย้าย source code ไปยังที่ commit ไว้ล่าสุด
```
git checkout master
```

#### git revert to commit

ถอย source code ไปยังจุดที่ commit ไว้

format : git reset --hard {comit id}
```
git reset --hard 8ec6
```

# Other


#### new branch from master. modify success
```
git format-patch --stdout master > my.patch
```


#### patch diff commit between n..n1 
```
git format-patch --stdout bb25e649fcbc539d99945600c262636621b48a3f..a427ce27eee37982312b7d7b8f2600c406109f20 > my.patch
```


#### zip file ที่มีความแตกต่าง ระหว่าง  commit ce1f8df - 8a22bd8
```
git archive -o update.zip HEAD $(git diff ce1f8df 8a22bd8 --name-only)
```




